/* GCC */
#include <fstream>
#include <iostream>
#include <vector>
using namespace std;

typedef unsigned int ul;

class Monitor{
public:
    vector<vector<ul> > screen;
    int W, H;
    int rw, rh;

    Monitor(int W, int H, int rw, int rh) {
        this->W = W;
        this->H = H;
        this->rw = rw;
        this->rh = rh;
        screen = vector<vector<ul> >(H);
        for (int i=0; i<H; i++) {
            screen[i] = vector<ul>(W);
            for (int j=0; j<W; j++) {
                screen[i].push_back(0);
            }
        }
    }

    void draw(int left, int top, ul color) {
        for(int i=0; i<rh; i++) {
            for(int j=0; j<rw; j++) {
                screen[top+i][left+j] = color;
                //cout << "(" << top+i << "; " << left+j << ") ";
            }
        }
        //cout << "to " << color << endl;
    }
};

int main()
{
    int W, H;
    int rw, rh;
    int N;
    ifstream in("monitor.in");

    in >> W  >> H;
    in >> rw >> rh;
    in >> N;
    Monitor m(W, H, rw, rh);

    for(int i=0; i<N; i++) {
        int left, top;
        ul color;
        in >> left >> top >> color;
        m.draw(left, top, color);
    }

    in.close();
    ofstream out("monitor.out");

    for (int i=0; i<H; i++) {
        for(int j=0; j<W; j++) {
            out << m.screen[i][j];
            if (j!=W-1) out << " ";
        }
        out << endl;
    }

    out.close();

    return 0;
}
