/* Java */

import java.io.*;

public class mouse {

    private static final String FILE_NAME = "mouse";

    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new FileReader(FILE_NAME + ".in"));
        PrintWriter pw = new PrintWriter(new FileWriter(FILE_NAME + ".out"));
        int result = 0;

        // mouse state
        boolean leftButtonDown = false;
        double doubleClickStart = -1;
        boolean doubleClickStarted = false;
        boolean doubleClickSecondStep = false;
        boolean rightButtonDown = false;

        // processing
        int n = Integer.parseInt(in.readLine());
        for (int i = 0; i < n; i++) {
            String[] spl = in.readLine().split(" ");
            int actionType = Integer.parseInt(spl[0]);
            double timestamp = Double.parseDouble(spl[1]);

            switch(actionType) {
                case 1:
                    // left button press
                    if (!leftButtonDown && !rightButtonDown) {
                        if (!doubleClickStarted) {
                            doubleClickStarted = true;
                            doubleClickSecondStep = false;
                            doubleClickStart = timestamp;
                        } else {
                            if (doubleClickSecondStep) {
                                doubleClickStarted = false;
                                doubleClickSecondStep = false;
                                double elapsed = timestamp - doubleClickStart;
                                // System.out.println("DoubleClick elapsed: " + elapsed);

                                if (elapsed <= 0.5f) {
                                    result++;
                                }
                            }
                        }
                    }
                    leftButtonDown = true;
                    break;
                case 2:
                    // left button release
                    leftButtonDown = false;
                    if (doubleClickStarted && !doubleClickSecondStep) {
                        doubleClickSecondStep = true;
                    }
                    break;
                case 3:
                    // right button press
                    rightButtonDown = true;
                    doubleClickStart = -1;
                    doubleClickStarted = false;
                    doubleClickSecondStep = false;
                    break;
                case 4:
                    // right button release
                    rightButtonDown = false;
                    doubleClickStart = -1;
                    doubleClickStarted = false;
                    doubleClickSecondStep = false;
                    break;
            }
        }

        pw.println(result);
        pw.close();
        in.close();
    }

}
